package io.embrace.android.embracesdk.annotation

/**
 * Classes and methods marked with this annotation are part of Embrace's Beta API that will only function if the app using it is
 * enrolled in the related feature's Beta program. Even then, they are not guaranteed to be supported going forward, and any changes to
 * them that break source compatibility can be made in future SDK versions without prior warning.
 *
 * If you are interested in trying out any Beta APIs, please contact your Embrace representative or reach out directly through the website.
 */
public annotation class BetaApi
