package io.embrace.android.embracesdk.internal

import android.os.Build
import android.os.Build.VERSION_CODES.LOLLIPOP
import android.os.Build.VERSION_CODES.TIRAMISU
import androidx.test.ext.junit.runners.AndroidJUnit4
import org.junit.Assert.assertEquals
import org.junit.Assert.assertSame
import org.junit.Test
import org.junit.runner.RunWith
import org.robolectric.annotation.Config

@RunWith(AndroidJUnit4::class)
internal class SystemInfoTest {

    @Config(sdk = [TIRAMISU])
    @Test
    fun `verify default system info for API 33`() {
        // Not all attributes are verified given some are just stubs generated by the testing framework
        with(SystemInfo()) {
            assertEquals("android", osName)
            assertEquals("linux", osType)
            assertEquals("33", androidOsApiLevel)
            assertEquals("13", osVersion)
            assertSame(Build.VERSION.BASE_OS, osBuild)
        }
    }

    @Config(sdk = [LOLLIPOP])
    @Test
    fun `verify default system info for API 21`() {
        with(SystemInfo()) {
            assertEquals("android", osName)
            assertEquals("linux", osType)
            assertEquals("21", androidOsApiLevel)
            assertEquals("5.0.2", osVersion)
            assertEquals("", osBuild)
        }
    }
}
